
class Indicator {                                // all indicators react very similar - therefore a class
  private:
    uint32_t previousMillis;                     // last time shown
    bool active = false;                         // indicator is shown
    const byte character;                        // the character to be displayed
    const byte col;                              // on which column
    const byte row;                              // on which row
    const uint16_t interval;                     // how long visible (after that time, the indicator will disapear)
  public:
    Indicator(byte character, byte col, byte row, uint16_t interval = 512) :
      character(character), col(col), row(row), interval(interval) {}
    void onIfNotActive() {       
      if (active == false)
      {
        lcd.setCursor(col, row);
        lcd.write(character);
        previousMillis = millis();
      }
      active = true;
    }
    void on() {
      active = true;
      lcd.setCursor(col, row);
      lcd.write(character);
      previousMillis = millis();
    }
    void off() {
      if (active == true)
      {
        lcd.setCursor(col, row);
        lcd.write(' ');
      }
      active = false;
    }
    void display() {
      lcd.setCursor(col, row);
      active ?  lcd.write(' ') : lcd.write(character);
    }
    void update() {                              // to be called in loop()
      if (active == true && interval > 0)
      {
        if (millis() - previousMillis > interval)
        {
          off();
        }
      }
    }
};
