/*
   Modbus Diagnostic - Passthrough

   just prints each received byte on SoftSerial to Serial.

   by noiaca

   2021-11-03
*/
#include <SoftwareSerial.h>
SoftwareSerial mySerial(2, 3);     // RX, TX
constexpr byte TxEnablePin = 11;

void setup() {
  Serial.begin(115200);
  Serial.println(F("\nModbus Diagnostic Passthrough"));
  mySerial.begin(19200);
}

void loop() {
  static uint8_t counter = 0;
  const uint8_t linefeed = 20;
  static uint32_t previousMillis=0;
  const uint16_t timeout = 1000; // automatic linefeed after ms idle

  pinMode(TxEnablePin, OUTPUT);
  digitalWrite(TxEnablePin, LOW);
  if (mySerial.available())
  {
    Serial.print(" ");
    Serial.print(mySerial.read(), HEX);
    counter++;
    previousMillis = millis();
    if (counter >= linefeed)
    {
      counter = 0;
      Serial.println();
    }
  }
  if (millis() - previousMillis > timeout && counter > 0)
  {
    Serial.println();
    counter = 0;
  }
}
