/*

  Variables and Definitions valid for several LCD Examples of Modbus Client and Modbus Server
  (Modbus Master and Modbus Slave)

*/
#pragma once
// FC6/FC16 use register 0 (40001) to write multiple values to the LCD
constexpr uint16_t addrWrite =        200;
constexpr uint16_t addrWriteOld =     201;
constexpr uint16_t addrBegin =        300;
constexpr uint16_t addrSetDelay =     301;
constexpr uint16_t addrCommand =      302;
constexpr uint16_t addrClear =        303;
constexpr uint16_t addrHome =         304;
constexpr uint16_t addrSetCursor =    305;
constexpr uint16_t addrCursor =       306;
constexpr uint16_t addrBlink =        307;
constexpr uint16_t addrSetBacklight = 308;
constexpr uint16_t addrStream =       900;       // FC6/FC16 - but mainly FC16 - 2 bytes in one 16bit - prints currently all characters breaks with odd characters
constexpr uint16_t addrStreamExpand = 901;       // FC6/FC16 prints only low nibble from value ein Byte/Zeichen pro 16bit register - - Umstellen auf 1100?
constexpr uint16_t addrCreateChar =   903;

// if you expand this list, you must also modify the callback for isValidAddress 
// which is predefined as mslrIsValidAddress in NoiascaModbusServerLCDReceiver.h

//more ideas to be done one day:
//  addrSetFont 
//  SPLASHSCREEN,      // SI: Show splash screen in Seconds - persist to EEPROM
//  addrUptime  2 register
